import { OnchangeCallback } from '@equinor/workspace-core';
import { FetchData } from '../types';
export declare class FetchController<TData> {
    private fetch;
    setFetch: (fetch: FetchData<TData>) => void;
    reset: () => void;
    /** Returns true if it aborted an api call */
    abort: () => boolean;
    private currAbort?;
    constructor(fetch: FetchData<TData>);
    /** Function for fetching data */
    getDataAsync: () => Promise<TData[] | undefined>;
    private dataPromise?;
    /** The data */
    data: TData[] | undefined;
    /** Set new data */
    private setData;
    /** Add a callback to fire when data changes */
    onDataChanged: (callback: OnchangeCallback<TData[]>) => () => void;
    /** True if its fetching for the first time */
    isLoading: boolean;
    private setIsLoading;
    /** Callback to fire when isLoading changes */
    onIsLoadingChanged: (callback: OnchangeCallback<boolean>) => () => void;
    private setIsFetching;
    /** True if currently fetching data */
    isFetching: boolean;
    /** Callback to fire when isFetching changes */
    onIsFetchingChanged: (callback: OnchangeCallback<boolean>) => () => void;
    destroy: () => void;
}
